import { HttpService } from '@nestjs/common';
import { ConfigService } from '../../config/config.service';
export declare class CargaService {
    private readonly httpService;
    private readonly config;
    descontos: string[][];
    private metaPersistent;
    private metaView;
    constructor(httpService: HttpService, config: ConfigService);
    private newObject;
    private parseCargaPersistent;
    private setAuxProperties;
    transform(file: any, operation: string, tipoCarga: string): Promise<{
        content: any[];
        persistentContent: any[];
        errorList: any[];
        meta: {
            cod_doc_impreso: {
                typeIn: string;
                required: boolean;
            };
            fe_emision: {
                typeIn: string;
                required: boolean;
                maxSize: number;
                isDate: boolean;
            };
            doc_orides: {
                typeIn: string;
                required: boolean;
            };
            obs: {
                typeIn: string;
                maxSize: number;
            };
            fe_cierre_carga: {
                typeIn: string;
                maxSize: number;
                isDate: boolean;
                required: boolean;
            };
            peso_bruto: {
                typeIn: string;
                required: boolean;
            };
            peso_tara: {
                typeIn: string;
                required: boolean;
            };
            peso_neto: {
                typeIn: string;
                required: boolean;
            };
            cod_transportadora: {
                typeIn: string;
            };
            nom_chofer: {
                typeIn: string;
                maxSize: number;
            };
            doc_chofer: {
                typeIn: string;
                maxSize: number;
            };
            direccion_chofer: {
                typeIn: string;
                maxSize: number;
            };
            tipo_transporte: {
                typeIn: string;
                maxSize: number;
            };
            modelo_tractor: {
                typeIn: string;
                maxSize: number;
            };
            nro_camion: {
                typeIn: string;
            };
            chapa_camion: {
                typeIn: string;
                maxSize: number;
            };
            chapa_remolque: {
                typeIn: string;
                maxSize: number;
            };
            cod_resp_flete: {
                typeIn: string;
                maxSize: number;
            };
            cod_chofer: {
                typeIn: string;
            };
            cod_unid_veic_camion: {
                typeIn: string;
            };
            tp_neg_flete: {
                typeIn: string;
                maxSize: number;
            };
            peso_neto_orides: {
                typeIn: string;
            };
            peso_liquido_orides: {
                typeIn: string;
            };
            cod_analista: {
                typeIn: string;
            };
        };
    }>;
    ajusteTrading(carga: any, operation: any, tipoCarga: any): any;
    ajustarDescontos(cargaRetorno: any): any;
    codigoDesconto(col: any): number;
    isColunaDesconto(e: any): boolean;
    validarEstrutura(carga: any): Promise<any>;
    private extractData;
    getMetaFetch(): void;
    private addError;
    private lowerProperties;
}
