"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const XLSX = require("xlsx");
const TokenGenerator = require("uuid-token-generator");
const common_1 = require("@nestjs/common");
const moment = require("moment");
const node_fetch_1 = require("node-fetch");
const config_service_1 = require("../../config/config.service");
const meta_trading_simplificado_1 = require("../meta/meta-trading-simplificado");
const tokgen = new TokenGenerator();
let CargaService = class CargaService {
    constructor(httpService, config) {
        this.httpService = httpService;
        this.config = config;
        this.descontos = [
            ['1', 'HUMEDAD'],
            ['2', 'CUERPO EXTRANO'],
            ['3', 'HUMEDAD GIRASOL'],
            ['4', 'IMPUREZA'],
            ['5', 'AVERIADOS'],
            ['6', 'CALCINADOS'],
            ['7', 'PARTIDOS'],
            ['8', 'VERDOSO'],
            ['9', 'PH'],
            ['10', 'DESCONTO PESO FUNDA'],
            ['11', 'BROTADOS'],
            ['12', 'ARDIDOS Y VERDOSOS'],
            ['14', 'MONSANTO RR1'],
            ['15', 'MONSANTO RR2']
        ];
        this.metaView = meta_trading_simplificado_1.META_TRADING_SIMPLIFICADO;
        this.getMetaFetch();
    }
    newObject(meta) {
        return __awaiter(this, void 0, void 0, function* () {
            const newObj = {};
            yield Object.keys(meta).forEach((key) => __awaiter(this, void 0, void 0, function* () {
                const keyname = key.toLowerCase();
                if (meta[keyname].hasOwnProperty('default')) {
                    newObj[keyname] = meta[keyname].default;
                }
                else {
                    newObj[keyname] = null;
                }
            }));
            return newObj;
        });
    }
    parseCargaPersistent(carga) {
        return __awaiter(this, void 0, void 0, function* () {
            const newCarga = yield this.newObject(this.metaPersistent);
            Object.assign(newCarga, carga);
            delete newCarga[`errorList`];
            return newCarga;
        });
    }
    setAuxProperties(tipoCarga) {
        if (tipoCarga in [meta_trading_simplificado_1.CARGA_ROMANEO, meta_trading_simplificado_1.CARGA_REMISION]) {
            this.metaView = Object.assign({}, this.metaView, meta_trading_simplificado_1.META_TRADING_SIMPLIFICADO_ENTIDADE);
        }
        else if (tipoCarga in [meta_trading_simplificado_1.CARGA_ROMANEO_CONTRATO, meta_trading_simplificado_1.CARGA_REMISION_CONTRATO]) {
            this.metaView = Object.assign({}, this.metaView, meta_trading_simplificado_1.META_TRADING_SIMPLIFICADO_CONTRATO);
        }
        else if (tipoCarga === meta_trading_simplificado_1.CARGA_REMISION_DESPACHO) {
            this.metaView = Object.assign({}, this.metaView, meta_trading_simplificado_1.META_TRADING_SIMPLIFICADO_DESPACHO);
        }
    }
    transform(file, operation, tipoCarga) {
        return __awaiter(this, void 0, void 0, function* () {
            this.setAuxProperties(parseInt(tipoCarga, 10));
            let workBook = null;
            let jsonData;
            const cargaRetorno = [];
            const cargasPersistent = [];
            let errorList = [];
            let contadorRegistro = 0;
            workBook = XLSX.readFile(file.path);
            jsonData = yield workBook.SheetNames.reduce((initial, name) => {
                const sheet = workBook.Sheets[name];
                const cargas = XLSX.utils.sheet_to_json(sheet);
                return cargas;
            }, {});
            for (const c of jsonData) {
                this.lowerProperties(c);
                contadorRegistro++;
                let carga = Object.assign({ num_sequence: contadorRegistro, uuid: tokgen.generate(256, TokenGenerator.BASE62) }, this.ajusteTrading(c, operation, tipoCarga));
                carga = this.ajustarDescontos(carga);
                carga = yield this.validarEstrutura(carga);
                const cargaPersistent = yield this.parseCargaPersistent(carga);
                cargasPersistent.push(cargaPersistent);
                errorList = errorList.concat(carga.errorList);
                cargaRetorno.push(Object.assign({}, carga));
            }
            return { content: cargaRetorno, persistentContent: cargasPersistent, errorList, meta: this.metaView };
        });
    }
    ajusteTrading(carga, operation, tipoCarga) {
        if (operation === 'trading') {
            carga = Object.assign({}, carga, { cod_tp_carga: parseInt(tipoCarga, 10) });
        }
        return carga;
    }
    ajustarDescontos(cargaRetorno) {
        const listaDescontos = [];
        const colunas = Object.keys(cargaRetorno);
        colunas.forEach(c => {
            if (this.isColunaDesconto(c)) {
                const desc = {
                    uuid: cargaRetorno.UUID,
                    cod_desconto: this.codigoDesconto(c),
                    percentual_descontado: cargaRetorno[c],
                    percentual_analisado: 0,
                    peso_descontado: 0,
                    analise_eletronica: 'N'
                };
                listaDescontos.push(desc);
                delete cargaRetorno[c];
            }
        });
        return Object.assign({}, cargaRetorno, { descontos: listaDescontos });
    }
    codigoDesconto(col) {
        return Number(this.descontos.filter(e => e[1].toLowerCase() === col)[0][0]);
    }
    isColunaDesconto(e) {
        return this.descontos.map(d => d[1]).some(element => element.toLowerCase() === e);
    }
    validarEstrutura(carga) {
        return __awaiter(this, void 0, void 0, function* () {
            const cargasValidadas = [];
            const errosMetaDados = [];
            yield Object.keys(this.metaView).forEach(key => {
                const meta = this.metaView[key];
                const cargaIndex = Object.keys(carga).findIndex(c => c.toLowerCase() === key.toLowerCase());
                if (cargaIndex > 0) {
                    if (meta.required) {
                        if (!carga[key]) {
                            errosMetaDados.push(this.addError(`Required`, key.toLowerCase(), carga.num_sequence));
                            return;
                        }
                    }
                    else {
                        if (!carga[key]) {
                            return;
                        }
                    }
                    if (meta.isDate) {
                        carga[key] = this.extractData(carga[key]);
                        if (!moment(carga[key], 'DD/MM/YYYY HH:mm:ss', true).isValid()) {
                            errosMetaDados.push(this.addError(meta.typeIn, key.toLowerCase(), carga.num_sequence));
                            return;
                        }
                    }
                    if (meta.typeIn === 'Number') {
                        if (isNaN(carga[key])) {
                            errosMetaDados.push(this.addError(meta.typeIn, key.toLowerCase(), carga.num_sequence));
                            return;
                        }
                    }
                }
                else {
                    if (meta.required) {
                        errosMetaDados.push(this.addError(`Required`, key.toLowerCase(), carga.num_sequence));
                    }
                }
            });
            carga.errorList = errosMetaDados;
            cargasValidadas.push(carga);
            return carga;
        });
    }
    extractData(value) {
        let strDate = null;
        try {
            strDate = value.replace(/'/gi, '');
            strDate = strDate.replace(/\s\s/gi, ' ');
            strDate = strDate.replace(/[\|&;\$%@"<>\(\)\+,]/g, '');
            if (moment(strDate, 'DD/MM/YYYY', true).isValid()) {
                strDate = value.concat(' 00:00:01');
            }
        }
        catch (e) {
            return value;
            console.error('Erro de conversion', e);
        }
        return strDate;
    }
    getMetaFetch() {
        node_fetch_1.default(this.config.get('ETL_CARGA_API_URI_META'))
            .then(response => response.json())
            .then(data => {
            this.metaPersistent = data;
        })
            .catch(error => console.error(error));
    }
    addError(typeIn, apiName, uuid) {
        let newMessage = '';
        if (typeIn === 'Required') {
            newMessage = `columna ${apiName} de la carga ${uuid} es obligatoria`;
        }
        else if (typeIn === 'Number') {
            newMessage = `columna ${apiName} de la carga ${uuid} debe ser numero`;
        }
        else if (typeIn === 'Date') {
            newMessage = `columna ${apiName} de la carga ${uuid} debe ser una fecha`;
        }
        return { atributo: apiName, mensagem: newMessage };
    }
    lowerProperties(carga) {
        return __awaiter(this, void 0, void 0, function* () {
            yield Object.keys(carga).forEach((key) => __awaiter(this, void 0, void 0, function* () {
                const keyLower = key.toLowerCase();
                let valueXls = carga[key];
                yield Object.keys(this.metaView).forEach(m => {
                    if (keyLower === m.toLowerCase()) {
                        valueXls = (this.metaView[m].typeIn === 'Number') ? parseInt(valueXls) : valueXls.toString();
                        delete carga[key];
                        carga[keyLower] = valueXls;
                        return true;
                    }
                });
            }));
            return carga;
        });
    }
};
CargaService = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [common_1.HttpService,
        config_service_1.ConfigService])
], CargaService);
exports.CargaService = CargaService;
//# sourceMappingURL=carga.service.js.map