"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@nestjs/core");
const app_module_1 = require("./app.module");
const swagger_1 = require("@nestjs/swagger");
function bootstrap() {
    return __awaiter(this, void 0, void 0, function* () {
        const portaListen = process.env.TransformationPort;
        const app = yield core_1.NestFactory.create(app_module_1.AppModule);
        app.enableCors();
        const options = new swagger_1.DocumentBuilder()
            .setTitle('LiquidEtl Transformer')
            .setDescription('Api para transformación de archivos para json.')
            .setVersion('1.0')
            .addTag('transformer')
            .build();
        const document = swagger_1.SwaggerModule.createDocument(app, options);
        swagger_1.SwaggerModule.setup('doc', app, document);
        yield app.listen(portaListen);
        console.log('listening on port ', portaListen);
        console.log('file path ', process.env.TransformationFilePath);
    });
}
bootstrap();
//# sourceMappingURL=main.js.map