"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const platform_express_1 = require("@nestjs/platform-express");
const transformer_service_1 = require("./transformer.service");
const multer_1 = require("multer");
const TokenGenerator = require("uuid-token-generator");
const swagger_1 = require("@nestjs/swagger");
const validation_service_1 = require("../validation/validation.service");
const fs_1 = require("fs");
const tokgen = new TokenGenerator();
let TransformerController = class TransformerController {
    constructor(service, validation) {
        this.service = service;
        this.validation = validation;
    }
    uploadFile(req, file) {
        return __awaiter(this, void 0, void 0, function* () {
            const retorno = {
                token_do_processo: tokgen.generate(256, TokenGenerator.BASE62),
                content: [],
                persistentContent: [],
                errorList: [],
                meta: {}
            };
            this.validation.isXlSXFile(file, 'tipo de archivo debe ser xls o xlsx');
            this.validation.isRequired(req.headers.module, `debes pasar el [module] en Header de la requisición`);
            this.validation.isRequired(req.headers.operation, `debes pasar el [operation] en Header de la requisición`);
            this.validation.isRequired(req.headers.tipo_carga, `debes pasar el [tipo_carga] en Header de la requisición`);
            if (!this.validation.isValid()) {
                retorno.errorList = this.validation.errors();
                this.validation.clear();
                throw new common_1.HttpException(retorno, common_1.HttpStatus.BAD_REQUEST);
            }
            const jsonTransform = yield this.service.transformFile(file, req.headers.module, req.headers.operation, req.headers.tipo_carga);
            retorno.content = jsonTransform[`content`];
            retorno.persistentContent = jsonTransform[`persistentContent`];
            retorno.errorList = jsonTransform[`errorList`];
            retorno.meta = jsonTransform[`meta`];
            return yield retorno;
        });
    }
};
__decorate([
    swagger_1.ApiImplicitBody({
        name: `file`,
        type: String,
        description: 'Archivo para importación',
        required: true,
        isArray: false
    }),
    common_1.Post('/xls'),
    common_1.Header('module', 'none'),
    common_1.UseInterceptors(platform_express_1.FileInterceptor('file', {
        storage: multer_1.diskStorage({
            destination: (req, file, cb) => {
                let uploadPath = process.env.TransformationFilePath;
                if (!fs_1.existsSync(uploadPath)) {
                    fs_1.mkdirSync(uploadPath);
                }
                cb(null, uploadPath);
            },
            filename: (req, file, cb) => {
                return cb(null, `${file.originalname}`);
            }
        })
    })),
    __param(0, common_1.Req()),
    __param(1, common_1.UploadedFile()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], TransformerController.prototype, "uploadFile", null);
TransformerController = __decorate([
    common_1.Controller('transformer'),
    __metadata("design:paramtypes", [transformer_service_1.TransformerService,
        validation_service_1.ValidationService])
], TransformerController);
exports.TransformerController = TransformerController;
//# sourceMappingURL=transformer.controller.js.map